0%

两数之和

题目地址

题目名称:两数之和

难度:

题目描述:

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

示例:

1
2
3
4
给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️解题过程🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️🙋‍♂️

下面是自己提交通过的代码:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
#include<iostream>
#include<vector>
using namespace std;
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
//创建vector容器,有2个元素,初始值默认为0
vector<int> arr(2);
//获取容器元素个数
int len=nums.size();
for(int i=0;i<len;i++){
for(int j=i+1;j<len;j++){
if(nums[i]+nums[j]==target){
arr[0]=i;
arr[1]=j;
}
}
}
return arr;
}
};

int main(){
//定义s,类型为Solution
Solution s;
//初始化vector容器nums
vector<int> nums{2,7,11,15};
int target=9;
//调用对象s的twoSum函数,返回值是vector容器类型
vector<int> result=s.twoSum(nums,target);
//遍历vector容器
cout<<"["<<result[0]<<","<<result[1]<<"]"<<endl;
}

注:代码是在codeblocks上编写的完整版,提交答案的时候只需要提交Solution类的代码就可以。

💎💎💎💎💎💎💎💎💎💎💎💎💎💎💎官 方 题 解💎💎💎💎💎💎💎💎💎💎💎💎💎💎💎

方法一:暴力枚举
思路及算法

最容易想到的方法是枚举数组中的每一个数 x,寻找数组中是否存在 target - x

当我们使用遍历整个数组的方式寻找 target - x 时,需要注意到每一个位于 x 之前的元素都已经和 x 匹配过,因此不需要再进行匹配。而每一个元素不能被使用两次,所以我们只需要在 x 后面的元素中寻找 target - x

代码

1
2
3
4
5
6
7
8
9
10
11
12
13
class Solution {
public int[] twoSum(int[] nums, int target) {
int n = nums.length;
for (int i = 0; i < n; ++i) {
for (int j = i + 1; j < n; ++j) {
if (nums[i] + nums[j] == target) {
return new int[]{i, j};
}
}
}
return new int[0];
}
}

复杂度分析

  • 时间复杂度:O(N2),其中N是数组中的元素数量。最坏情况下数组中任意两个数都要被匹配一次。
  • 空间复杂度:O(1)

方法二:哈希表
思路及算法

注意到方法一的时间复杂度较高的原因是寻找 target - x 的时间复杂度过高。因此,我们需要一种更优秀的方法,能够快速寻找数组中是否存在目标元素。如果存在,我们需要找出它的索引。

使用哈希表,可以将寻找 target - x 的时间复杂度降低到从 O(N) 降低到 O(1)

这样我们创建一个哈希表,对于每一个 x,我们首先查询哈希表中是否存在 target - x,然后将 x 插入到哈希表中,即可保证不会让 x 和自己匹配。

代码

1
2
3
4
5
6
7
8
9
10
11
12
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; ++i) {
if (hashtable.containsKey(target - nums[i])) {
return new int[]{hashtable.get(target - nums[i]), i};
}
hashtable.put(nums[i], i);
}
return new int[0];
}
}

复杂度分析

  • 时间复杂度:O(N),其中N是数组中的元素数量。对于每一个元素x,我们可以O(1)地寻找target-x
  • 空间复杂度:O(N),其中N是数组中的元素数量。主要为哈希表的开销。
⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳总 结⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳⏳

这好像是我在LeetCode平台上面做的第一道题,好久没用C++了,知识点都忘了,最近python写多了编程序时有几个error就是按python语法写的🤣。上周就看这道题了,看到题目已经给出的部分代码,vector容器我没咋用过啊,当时就乱写最后不是这个测试用例不通过就是那个出错,所以我就用了一周多的时间把菜鸟教程上c&c++又学习了一遍,STL标准模板库没来得及看完,就把这道题需要的vector容器看了。提交完答案看官方题解分析,自己用的是第一种方法暴力枚举,效率确实不是很高啊😅;第二种方法是使用了哈希表,确实是一种更优秀的方法,也是属于STL的范畴,看来我还得抽时间赶紧把C++的STL标准模板库给学了。c&c++基础已经复习完了,题目也可以开始刷起来了,希望以后持续的做LeetCode题,将来的你一定会感谢现在拼命的自己,加油🎈

------------- THE END! THANKS! -------------